/*
 *  linux/arch/nds32/include/asm/cache.h
 *  Copyright (C) 2008 Andes Technology Corporation
 */

#ifndef __NDS32_CACHE_H__
#define __NDS32_CACHE_H__

#define L1_CACHE_BYTES	32
#define L1_CACHE_SHIFT	5

/*
 *  * Memory returned by kmalloc() may be used for DMA, so we must make
 *   * sure that all such allocations are cache aligned. Otherwise,
 *    * unrelated code may cause parts of the buffer to be read into the
 *     * cache before the transfer is done, causing old data to be seen by
 *      * the CPU.
 *       */
#define ARCH_DMA_MINALIGN   L1_CACHE_BYTES


#endif /* __NDS32_CACHE_H__ */
