#ifndef _NDS32_HW_BREAKPOINT_H
#define _NDS32_HW_BREAKPOINT_H

#ifdef __KERNEL__
/* Total number of available HW breakpoint registers */

#ifdef CONFIG_NDS32_EDM_SUP
#define HBP_MAX_NUM 8

#define VIRTUAL_ADDR 0
#define PHYSICAL_ADDR 1

#define NDS32_EDM_CFG_BC_OFFSET 0
#define NDS32_EDM_CFG_BC (0x7<<NDS32_EDM_CFG_BC_OFFSET)

enum nds32_hw_bptype {
	NDS32_HW_BREAKPOINT = 1,
	NDS32_WRITE_WATCHPOINT,
	NDS32_READ_WATCHPOINT,
	NDS32_ACCESS_WATCHPOINT,
};

typedef struct nds32_edm_info_s
{
	//unsigned int EDM_config;
	unsigned int total_bp_num;
	unsigned int complex_bp_num;
	unsigned int complex_bp_bit_filed;
	unsigned int simple_bp_num;
	unsigned int occupied_simple_bp_num;
}nds32_edm_info_t;

typedef struct nds32_edm_bpreg_s
{
	//unsigned int EDM_config;
	unsigned int bpc_val;
	unsigned int bpa_val;
	unsigned int bpam_val;
	unsigned int bpdv_val;
	unsigned int bpc_id_val;
}nds32_edm_bpreg_t;

extern nds32_edm_info_t nds32_edm_cfg;
extern int nds32_set_hw_break(unsigned long addr,int addr_type, int len, enum nds32_hw_bptype type);
extern int nds32_remove_hw_break(unsigned long addr, int len, enum nds32_hw_bptype type);
extern void nds32_remove_all_hw_break(void);
extern void nds32_correct_hw_break(void);
extern void nds32_disable_all_edm_bpc(void);
#define NDS32_DBG_READ(REG_NUM,VAL) \
	asm volatile("mfsr\t%0, $dr"#REG_NUM"\n\t" : "=r" (VAL));

#define NDS32_DBG_WRITE(REG_NUM,VAL) \
	asm volatile("mtsr\t%0, $dr"#REG_NUM"\n\t" : : "r" (VAL));

#endif //__KERNEL__
#endif //CONFIG_NDS32_EDM_SUP
#endif //_NDS32_HW_BREAKPOINT_H
