/*
 *  linux/arch/nds32/include/asm/irqflags.h
 *  Copyright (C) 2008 Andes Technology Corporation
 */

#include <asm/nds32.h>
#include <asm/assembler.h>

#define arch_local_irq_disable()	\
	GIE_DISABLE();

#define arch_local_irq_enable()	\
	GIE_ENABLE();
static inline unsigned long arch_local_irq_save(void)
{
	unsigned long flags;
	__asm__ __volatile__(
	"mfsr   %0, $PSW\n"
	"andi   %0, %0, #0x1\n"
	"gie_disable\n"
	: "=r" (flags)
	:
	: "memory");
	return flags;
}
static inline unsigned long arch_local_save_flags(void)
{
	unsigned long flags;
	__asm__ __volatile__(
	"mfsr   %0, $PSW\n"
	"andi   %0, %0, #0x1"
	: "=r" (flags)
	:
	: "memory");
	return flags;
}
static inline void arch_local_irq_restore(unsigned long flags)
{
	__asm__ __volatile__(
	"beqz   %0, 1f\n"
	"gie_enable\n"
	"1:"
	:: "r" (flags)
	:"memory" );
}
static inline int arch_irqs_disabled_flags(unsigned long flags)
{
	return !flags;
}
