/*
 *  linux/arch/nds32/include/asm/mmu.h
 *  Copyright (C) 2008 Andes Technology Corporation
 */

#ifndef __NDS32_MMU_H
#define __NDS32_MMU_H

typedef struct {
	unsigned int id;
} mm_context_t;

#define ASID(mm)	((mm)->context.id & (TLB_MISC_mskCID >> TLB_MISC_offCID))
inline static unsigned long ACC_PSZ(unsigned long page_size)
{
	switch(page_size) {
		case(1<<12):
			return 0;
		case(1<<13):
			return 1;
		case(1<<14):
			return 2;
		case(1<<16):
			return 3;
		case(1<<18):
			return 4;
		case(1<<20):
			return 5;
		case(1<<22):
			return 6;
		case(1<<24):
			return 7;
		case(1<<26):
			return 8;
		case(1<<28):
			return 9;
		default:
			printk("Huge Page Size is not supported \n");
			return 0xffffffff;
	}
}
#endif
