/*
 *  linux/arch/nds32/include/asm/shmparam.h
 *  Copyright (C) 2008 Andes Technology Corporation
 */

#ifndef _ASMNDS32_SHMPARAM_H
#define _ASMNDS32_SHMPARAM_H

/*
 * This should be the size of the virtually indexed cache/ways,
 * whichever is greater since the cache aliases every size/ways
 * bytes.
 */
/* 
 * Reference ARM architecture, retain the previous code 
 * #define   SHMLBA  0x4000
 * #define   REALSHMLBA  (CACHE_SET( DCACHE) * CACHE_LINE_SIZE( DCACHE))
 */
#define	SHMLBA	(4 * PAGE_SIZE)	 /* attach addr a multiple of this */
#define	REALSHMLBA	SHMLBA

/*
 * Enforce SHMLBA in shmat
 */
#define __ARCH_FORCE_SHMLBA

#endif /* _ASMNDS32_SHMPARAM_H */
