/*
 *  linux/arch/nds32/include/asm/unaligned.h
 *  Copyright (C) 2008 Andes Technology Corporation
 */

#ifndef __ASM_NDS32_UNALIGNED_H
#define __ASM_NDS32_UNALIGNED_H

#include <linux/unaligned/le_byteshift.h>
#include <linux/unaligned/be_byteshift.h>
#include <linux/unaligned/generic.h>

/*
 * Select endianness
 */
#if defined(__NDS32_EB__)
#define get_unaligned   __get_unaligned_be
#define put_unaligned   __put_unaligned_be
#else
#define get_unaligned   __get_unaligned_le
#define put_unaligned   __put_unaligned_le
#endif

#endif /* __ASM_NDS32_UNALIGNED_H */
