#include <linux/module.h>
#include <asm/hw_breakpoint.h>
#include <linux/init.h>
#include <linux/kernel.h>
nds32_edm_info_t nds32_edm_cfg;
EXPORT_SYMBOL(nds32_edm_cfg);

static struct hw_breakpoint {
	unsigned int	enable;
	unsigned long 	addr;
	unsigned int	addr_type;
	unsigned int	length;
	unsigned int 	type;
} breakinfo[HBP_MAX_NUM];


static void nds32_write_edm_bpreg(int reg_num, nds32_edm_bpreg_t* nds32_edm_bpreg)
{
	switch(reg_num)
	{
		case 0:
			NDS32_DBG_WRITE(1, nds32_edm_bpreg->bpa_val);
			NDS32_DBG_WRITE(2, nds32_edm_bpreg->bpam_val);
			NDS32_DBG_WRITE(3, nds32_edm_bpreg->bpdv_val);
			NDS32_DBG_WRITE(4, nds32_edm_bpreg->bpc_id_val);
			NDS32_DBG_WRITE(0, nds32_edm_bpreg->bpc_val);
			break;
		case 1:
			NDS32_DBG_WRITE(6, nds32_edm_bpreg->bpa_val);
			NDS32_DBG_WRITE(7, nds32_edm_bpreg->bpam_val);
			NDS32_DBG_WRITE(8, nds32_edm_bpreg->bpdv_val);
			NDS32_DBG_WRITE(9, nds32_edm_bpreg->bpc_id_val);
			NDS32_DBG_WRITE(5, nds32_edm_bpreg->bpc_val);
			break;
		case 2:
			NDS32_DBG_WRITE(11, nds32_edm_bpreg->bpa_val);
			NDS32_DBG_WRITE(12, nds32_edm_bpreg->bpam_val);
			NDS32_DBG_WRITE(13, nds32_edm_bpreg->bpdv_val);
			NDS32_DBG_WRITE(14, nds32_edm_bpreg->bpc_id_val);
			NDS32_DBG_WRITE(10, nds32_edm_bpreg->bpc_val);
			break;
		case 3:
			NDS32_DBG_WRITE(16, nds32_edm_bpreg->bpa_val);
			NDS32_DBG_WRITE(17, nds32_edm_bpreg->bpam_val);
			NDS32_DBG_WRITE(18, nds32_edm_bpreg->bpdv_val);
			NDS32_DBG_WRITE(19, nds32_edm_bpreg->bpc_id_val);
			NDS32_DBG_WRITE(15, nds32_edm_bpreg->bpc_val);
			break;
		case 4:
			NDS32_DBG_WRITE(21, nds32_edm_bpreg->bpa_val);
			NDS32_DBG_WRITE(22, nds32_edm_bpreg->bpam_val);
			NDS32_DBG_WRITE(23, nds32_edm_bpreg->bpdv_val);
			NDS32_DBG_WRITE(24, nds32_edm_bpreg->bpc_id_val);
			NDS32_DBG_WRITE(20, nds32_edm_bpreg->bpc_val);
			break;
		case 5:
			NDS32_DBG_WRITE(26, nds32_edm_bpreg->bpa_val);
			NDS32_DBG_WRITE(27, nds32_edm_bpreg->bpam_val);
			NDS32_DBG_WRITE(28, nds32_edm_bpreg->bpdv_val);
			NDS32_DBG_WRITE(29, nds32_edm_bpreg->bpc_id_val);
			NDS32_DBG_WRITE(25, nds32_edm_bpreg->bpc_val);
			break;
		case 6:
			NDS32_DBG_WRITE(31, nds32_edm_bpreg->bpa_val);
			NDS32_DBG_WRITE(32, nds32_edm_bpreg->bpam_val);
			NDS32_DBG_WRITE(33, nds32_edm_bpreg->bpdv_val);
			NDS32_DBG_WRITE(34, nds32_edm_bpreg->bpc_id_val);
			NDS32_DBG_WRITE(30, nds32_edm_bpreg->bpc_val);
			break;
		case 7:
			NDS32_DBG_WRITE(36, nds32_edm_bpreg->bpa_val);
			NDS32_DBG_WRITE(37, nds32_edm_bpreg->bpam_val);
			NDS32_DBG_WRITE(38, nds32_edm_bpreg->bpdv_val);
			NDS32_DBG_WRITE(39, nds32_edm_bpreg->bpc_id_val);
			NDS32_DBG_WRITE(35, nds32_edm_bpreg->bpc_val);
			break;
	}


}
static void nds32_write_edm_bpc(int reg_num, unsigned long value)
{
	switch(reg_num)
	{
		case 0:
			NDS32_DBG_WRITE(0,value);
			break;
		case 1:
			NDS32_DBG_WRITE(5,value);
			break;
		case 2:
			NDS32_DBG_WRITE(10,value);
			break;
		case 3:
			NDS32_DBG_WRITE(15,value);
			break;
		case 4:
			NDS32_DBG_WRITE(20,value);
			break;
		case 5:
			NDS32_DBG_WRITE(25,value);
			break;
		case 6:
			NDS32_DBG_WRITE(30,value);
			break;
		case 7:
			NDS32_DBG_WRITE(35,value);
			break;
	}

}
static unsigned long nds32_read_edm_bpc(int reg_num)
{
	unsigned long value = 0;
	switch(reg_num)
	{
		case 0:
			NDS32_DBG_READ(0,value);
			break;
		case 1:
			NDS32_DBG_READ(5,value);
			break;
		case 2:
			NDS32_DBG_READ(10,value);
			break;
		case 3:
			NDS32_DBG_READ(15,value);
			break;
		case 4:
			NDS32_DBG_READ(20,value);
			break;
		case 5:
			NDS32_DBG_READ(25,value);
			break;
		case 6:
			NDS32_DBG_READ(30,value);
			break;
		case 7:
			NDS32_DBG_READ(35,value);
			break;
	}
	return value;
}
int nds32_set_hw_break(unsigned long addr, int addr_type, int len, enum nds32_hw_bptype type)
{
	int breakno;

	switch (type) {
	case NDS32_HW_BREAKPOINT:
	case NDS32_WRITE_WATCHPOINT:
	case NDS32_READ_WATCHPOINT:
	case NDS32_ACCESS_WATCHPOINT:
		break;
	default:
		return -ENOSPC;
	}

	for (breakno = 0; breakno < nds32_edm_cfg.total_bp_num ; breakno++)
	{
		if(breakinfo[breakno].enable != 0)
			continue;

		if(nds32_edm_cfg.complex_bp_bit_filed & (1<<breakno))
		{
			if((type == NDS32_HW_BREAKPOINT)
				&& (nds32_edm_cfg.occupied_simple_bp_num
					< nds32_edm_cfg.simple_bp_num))
				continue;
		}else
		{
			if(type != NDS32_HW_BREAKPOINT)
				continue;
			nds32_edm_cfg.occupied_simple_bp_num++;
		}
		breakinfo[breakno].enable = 1;
		breakinfo[breakno].addr = addr;
		breakinfo[breakno].addr_type = addr_type;
		breakinfo[breakno].length = len;
		breakinfo[breakno].type = type;
		return breakno;
	}
	return -ENOSPC;
}
EXPORT_SYMBOL(nds32_set_hw_break);
int nds32_remove_hw_break(unsigned long addr, int len, enum nds32_hw_bptype type)
{
	int breakno;

	for (breakno = 0; breakno < nds32_edm_cfg.total_bp_num; breakno++)
		if (type == breakinfo[breakno].type
			&& breakinfo[breakno].enable
			&& breakinfo[breakno].addr == addr) {
			breakinfo[breakno].enable = 0;
			if(0 == (nds32_edm_cfg.complex_bp_bit_filed & (1<<breakno)))
				nds32_edm_cfg.occupied_simple_bp_num--;
		}

	return 0;
}
EXPORT_SYMBOL(nds32_remove_hw_break);
void nds32_remove_all_hw_break(void)
{
	memset(breakinfo, 0, sizeof(struct hw_breakpoint)*HBP_MAX_NUM);
}
EXPORT_SYMBOL(nds32_remove_all_hw_break);
void nds32_correct_hw_break(void)
{
	int breakno;
	nds32_edm_bpreg_t nds32_edm_bpreg_val;
	for (breakno = 0; breakno < nds32_edm_cfg.total_bp_num; breakno++)
	{
		unsigned int addr_mask =0, bpc_config = 0;
		if (!breakinfo[breakno].enable)
			continue;

		addr_mask = breakinfo[breakno].length - 1;

		if (breakinfo[breakno].type == NDS32_HW_BREAKPOINT)
		{
			bpc_config = 0x2;
		}else
		{
			if( 0 != (breakinfo[breakno].addr % breakinfo[breakno].length))
				addr_mask = (addr_mask << 1) + 1;

			switch (breakinfo[breakno].type) {
			case NDS32_WRITE_WATCHPOINT:
				bpc_config = 0x5;
				break;
			case NDS32_READ_WATCHPOINT:
				bpc_config = 0x3;
				break;
			case NDS32_ACCESS_WATCHPOINT:
				bpc_config = 0x7;
				break;
			}
			if(breakinfo[breakno].addr_type == PHYSICAL_ADDR )
				bpc_config |= 0x8;
		}
		nds32_edm_bpreg_val.bpc_val = bpc_config;
		nds32_edm_bpreg_val.bpa_val = breakinfo[breakno].addr;
		nds32_edm_bpreg_val.bpam_val = addr_mask;
		nds32_edm_bpreg_val.bpdv_val = 0;
		nds32_edm_bpreg_val.bpc_id_val = 0;
		nds32_write_edm_bpreg(breakno, &nds32_edm_bpreg_val);
	}
}
EXPORT_SYMBOL(nds32_correct_hw_break);
void nds32_disable_all_edm_bpc(void)
{
	int breakno;
	for (breakno = 0; breakno < nds32_edm_cfg.total_bp_num; breakno++)
	{
		nds32_write_edm_bpc(breakno, 0);
	}
}
EXPORT_SYMBOL(nds32_disable_all_edm_bpc);
static int __init nds32_hw_breakpoint_init(void)
{
	unsigned int edm_config;
	int i;

	NDS32_DBG_READ(40,edm_config);
	nds32_edm_cfg.total_bp_num = (edm_config & NDS32_EDM_CFG_BC)+1;
	nds32_edm_cfg.simple_bp_num = 0;
	nds32_edm_cfg.complex_bp_num = 0;
	nds32_edm_cfg.complex_bp_bit_filed = 0;
	nds32_edm_cfg.occupied_simple_bp_num = 0;

	for(i=0; i<nds32_edm_cfg.total_bp_num; i++)
	{
                unsigned int orig_BPC_val = 0;
		unsigned int tmp_BPC_val = 0;

                orig_BPC_val = nds32_read_edm_bpc(i);

                /*
                 * Write the WP bit to test the hardware breakpoint
                 * is complex bp or simple bp.
                 * Simple bp is hardwire to zero.
                 */
		nds32_write_edm_bpc(i, 1);
		tmp_BPC_val = nds32_read_edm_bpc(i);
		if(tmp_BPC_val)
		{
			nds32_edm_cfg.complex_bp_bit_filed |= (1<<i);
			nds32_edm_cfg.complex_bp_num++;
		}else
			nds32_edm_cfg.simple_bp_num++;

                nds32_write_edm_bpc(i, orig_BPC_val);
	}
	return 0;
}
arch_initcall(nds32_hw_breakpoint_init);
