/*
 *  linux/arch/nds32/kernel/setup.c
 *
 *  Copyright (C) 1995-2001 Russell King
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */
/* ============================================================================
 *  Copyright (C) 2007 Andes Technology Corporation
 *  This file is part of Linux and should be licensed under the GPL.
 *  See the file COPYING for conditions for redistribution.
 *
 *  Abstract:
 *
 *  This program is for Andes NDS32 architecture.
 *
 *  Revision History:
 *
 *  Jul.05.2007 Initial ported by Tom, revised and patched for KGDB
 *    by Harry.
 *
 *  Note:
 *
 * ============================================================================
 */

#include <asm/procinfo.h>

struct proc_info_item info_item = {
	"AndesCore",
#ifndef CONFIG_CPU_ICACHE_DISABLE
	"I"
#endif
#ifndef CONFIG_CPU_DCACHE_DISABLE
	    "D"
#ifdef CONFIG_CPU_DCACHE_WRITETHROUGH
	    "(wt)"
#else
	    "(wb)"
#endif
#endif
};

struct proc_info_list n10_proc_info
    __attribute__ ((section(".proc.info.init"))) = {
.cpu_val = 0x0a000000,.cpu_mask = 0xff000000,.arch_name =
	    "NDS32 N10",.elf_name = "NDS32 ELF",.elf_hwcap = 0,.info =
	    &info_item,};

struct proc_info_list n12_proc_info
    __attribute__ ((section(".proc.info.init"))) = {
.cpu_val = 0x0c000000,.cpu_mask = 0xff000000,.arch_name =
	    "NDS32 N12",.elf_name = "NDS32 ELF",.elf_hwcap = 0,.info =
	    &info_item,};

struct proc_info_list n13_proc_info
    __attribute__ ((section(".proc.info.init"))) = {
.cpu_val = 0x0d000000,.cpu_mask = 0xff000000,.arch_name =
	    "NDS32 N13",.elf_name = "NDS32 ELF",.elf_hwcap = 0,.info =
	    &info_item,};

struct proc_info_list n968_proc_info
    __attribute__ ((section(".proc.info.init"))) = {
.cpu_val = 0x19000000,.cpu_mask = 0xff000000,.arch_name =
	    "NDS32 N968",.elf_name = "NDS32 ELF",.elf_hwcap = 0,.info =
	    &info_item,};

struct proc_info_list n1068_proc_info
    __attribute__ ((section(".proc.info.init"))) = {
.cpu_val = 0x1a000000,.cpu_mask = 0xff000000,.arch_name =
	    "NDS32 N1068",.elf_name = "NDS32 ELF",.elf_hwcap = 0,.info =
	    &info_item,};

// the last one (a roust way to do so)
struct proc_info_list nXX_proc_info
    __attribute__ ((section(".proc.info.init.last"))) = {
.cpu_val = 0x00000000,.cpu_mask = 0x00000000,.arch_name =
	    "NDS32 CPU",.elf_name = "NDS32 ELF",.elf_hwcap = 0,.info =
	    &info_item,};
