/*
 * linux/arch/nds32/kernel/ptrace.h
 */
/* Copyright (C) 2000-2003 Russell King
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */
/* ============================================================================
 *  Copyright (C) 2007 Andes Technology Corporation
 *  This file is part of Linux and should be licensed under the GPL.
 *  See the file COPYING for conditions for redistribution.
 *
 *  Abstract:
 *
 *    This program is for Andes NDS32 architecture.
 *
 *  Revision History:
 *
 *    Jul.31.2007     Initial ported by Tom, Shawn, and Steven,
 *                    revised by Harry.
 *                    Current implmentation is based on Andes Instruction
 *                    Set Architecture Specification (AS-0001-0001)
 *                    version:3.7 date:7-20-2007.
 *                    It is original taken from ARM, then fit to NDS32.
 *
 *  Note:
 *
 *    Current layout: 0-31 GR, 32-34 SPR, 35-... SR, index start from zero.
 *
 *      +----------+-----+--------------+
 *      |    GR    | SPR |      SR      |
 *      +-------------------------------+
 *      0          32    35             ...
 *
 * ============================================================================
 */
#ifndef __KERNEL_PTRACE_H__
#define __KERNEL_PTRACE_H__

extern void ptrace_cancel_swbk(struct task_struct *);
extern void ptrace_set_swbk(struct task_struct *);
extern void ptrace_break(struct task_struct *, struct pt_regs *);
extern void send_sigtrap(struct task_struct *tsk, struct pt_regs *regs,
					 int error_code, int si_code);

#endif // __KERNEL_PTRACE_H__
