/*
 * relocate_kernel.S - put the kernel image in place to boot
 */

#include <asm/kexec.h>

	.globl relocate_new_kernel
relocate_new_kernel:
	la	$r0, kexec_indirection_page
	slli	$r0, $r0, 2
	srli	$r0, $r0, 2
	lwi	$r0, [$r0]
	la	$r1, kexec_start_address
	slli	$r1, $r1, 2
	srli	$r1, $r1, 2
	lwi	$r1, [$r1]

0:	/* top, read another word for the indirection page */
	lwi.bi	$r3, [$r0], #4

	/* Is it a destination page. Put destination address to r4 */
	andi	$p0, $r3, #1
	beqz	$p0, 1f
	li	$p0, ~#1
	and	$r4, $r3, $p0
	b	0b
1:
	/* Is it an indirection page */
	andi	$p0, $r3, #2
	beqz	$p0, 1f
	li	$p0, ~#2
	and 	$r0, $r3, $p0
	b	0b
1:
	/* are we done ? */
	andi	$p0, $r3, #4
	beqz	$p0, 1f
	b	2f
1:
	/* is it source ? */
	andi	$p0, $r3, #8
	beqz	$p0, 0b
	li	$p0, ~#8
	and	$r3, $r3, $p0
	li	$r6, #(1024/16)	/* 16 words per loop */
9:
	lmw.bim $r7, [$r3], $r22
	smw.bim	$r7, [$r4], $r22
	addi	$r6, $r6, -1
	bnez	$r6, 9b
	b	0b
2:
	/* Jump to relocated kernel */
	move	$lp, $r1
	li	$r0, 0
	la	$r1, kexec_mach_type
	slli	$r1, $r1, 2
	srli	$r1, $r1, 2
	lwi	$r1, [$r1]
	la	$r2, kexec_boot_atags
	slli	$r2, $r2, 2
	srli	$r2, $r2, 2
	lwi	$r2, [$r2]
	ret

	.globl kexec_start_address
kexec_start_address:
	.long	0x0

	.globl kexec_indirection_page
kexec_indirection_page:
	.long	0x0

	.globl kexec_mach_type
kexec_mach_type:
	.long	0x0

	/* phy addr of the atags for the new kernel */
	.globl kexec_boot_atags
kexec_boot_atags:
	.long	0x0

relocate_new_kernel_end:

	.globl relocate_new_kernel_size
relocate_new_kernel_size:
	.long relocate_new_kernel_end - relocate_new_kernel


