/*
 *  linux/arch/nds32/lib/strchr.S
 *
 *  Copyright (C) 1995-2000 Russell King
 *  Copyright (C) 2009 Andes Technology Corporation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 *  ASM optimised string functions
 */
#include <linux/linkage.h>
#include <asm/assembler.h>

/*
 * Prototype: char *strrchr(const char *s, int c);
 * Purpose  : Returns a pointer to the first occurrence of the character c
 *            in the string s. Here "character" means "byte" - these functions
 *            do not work with wide or multi-byte characters.
 */

	.text

ENTRY(strchr)
	move	$r5, $r0	! Setup return value
	andi	$r1, $r1, #0xff	! Wipe out useless bits
loop:
	lbi.bi	$p0, [$r5], #1	! Load the next byte
	beqz	$p0, exit	! Reach EOS (NULL), return NULL
	bne	$p0, $r1, loop	! Continue if != c
	addi	$r5, $r5, #-1	! Found
exit:
	cmovz	$r5, $p0, $p0	! Return NULL if EOS (NULL)
	move	$r0, $r5
	ret

