/*
 *  linux/arch/nds32/lib/strncpy_from_user.S
 *
 *  Copyright (C) 1995-2000 Russell King
 *  Copyright (C) 2009 Andes Technology Corporation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */
#include <linux/linkage.h>
#include <asm/assembler.h>
#include <asm/errno.h>


/*
 * Copy a string from user space to kernel space.
 *  $r0 = dst, $r1 = src, $r2 = n (byte length)
 * returns the number of characters copied (strlen of copied string),
 *  -EFAULT on exception, or "len" if we fill the whole buffer
 */

	.text
	.align	4
ENTRY(__arch_strncpy_from_user)
	move	$p1, $r1	! Record the start src addr
loop:
	addi	$r2, $r2, #-1	! Decrease n by 1
	bltz	$r2, exit	! Exit if n < 0
USER(	lbi.bi,	$p0, [$r1], #1)	! Load the byte from src
	sbi.bi	$p0, [$r0], #1	! Store the byte to dst
	bnez	$p0, loop	! Continue looping if terminator is not reached
	addi	$r1, $r1, #-1	! Don't count the terminator
exit:
	sub	$r0, $r1, $p1	! Get copied count
	ret

	.section .fixup,"ax"
	.align	0
9001:	xor	$p0, $p0, $p0
	sb	$p0, [$r0]	! Zero the buffer
	move	$r0, -EFAULT	! Return -EFAULT
	ret
	.previous

