/*
 *  linux/arch/nds32/lib/strnlen_user.S
 *
 *  Copyright (C) 1995-2000 Russell King
 *  Copyright (C) 2009 Andes Technology Corporation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */
#include <linux/linkage.h>
#include <asm/assembler.h>
#include <asm/errno.h>

	.text

/* Prototype: unsigned long ___arch_strnlen_user(const char *str, long n)
 * Purpose  : get length of a string in user memory
 * Params   : str - address of string in user memory
 * Returns  : length of string *including terminator*
 *	      or zero on exception, or n + 1 if too long
 */
	.align	4
ENTRY(__arch_strnlen_user)
	move	$p0, $r0	! Record the start addr
	! beqz	$r0, exit	! Exit when Null address
	beqz	$r1, exit	! Exit when n = 0
loop:
USER(	lbi.bi,	$p1, [$r0], #1)	! Load the next byte
	beqz	$p1, exit	! Exit when terminator is reached
	addi	$r1, $r1, #-1	! Decrease n by 1
	bnez	$r1, loop	! Continue looping if n != 0
	addi	$r0, $r0, #1	! Return n+1 if too long
exit:
	sub	$r0, $r0, $p0	! Get the counted length
	ret

	.section .fixup,"ax"
	.align	0
9001:	move	$r0, #0		! Return 0 on exception
	ret
	.previous

