/*
 *  linux/arch/nds32/lib/strrchr.S
 *
 *  Copyright (C) 1995-2000 Russell King
 *  Copyright (C) 2009 Andes Technology Corporation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 *  ASM optimised string functions
 */
#include <linux/linkage.h>
#include <asm/assembler.h>

	.text
/*
 * Prototype: char *strrchr(const char *s, int c);
 * Purpose  : Returns a pointer to the last occurrence of the character c
 *            in the string s. Here "character" means "byte" - these functions
 *            do not work with wide or multi-byte characters.
 */
	.align	4
ENTRY(strrchr)
	move	$r5, #0
	beqz	$r0, exit
	andi	$r1, $r1, #0xff	! Wipe out useless bits
loop:
	lbi	$p0, [$r0]	! Load the next byte
	xor	$p1, $p0, $r1	! Test if the byte == c
	cmovz	$r5, $r0, $p1	! Save the current position
	addi	$r0, $r0, #1	! Move on to the next byte
	bnez	$p0, loop	! Continue if not NULL (EOS)
exit:
	move	$r0, $r5
	ret

