#include <linux/spinlock_types.h>
#include <linux/mm.h>
#include <linux/sched.h>
#include <asm/nds32.h>
#include <nds32_intrinsic.h>

unsigned int cpu_last_cid = { TLB_MISC_mskCID + (2 << TLB_MISC_offCID) };

DEFINE_SPINLOCK(cid_lock);

void local_flush_tlb_range(struct vm_area_struct *vma,
			   unsigned long start, unsigned long end)
{
	unsigned long flags, ocid, ncid;

	if ((end - start) > 0x400000) {
		asm("tlbop FLUA");
		__nds32__isb();
		return;
	}

	spin_lock_irqsave(&cid_lock, flags);
	ocid = GET_TLB_MISC();
	ncid = (ocid & ~TLB_MISC_mskCID) | vma->vm_mm->context.id;
	SET_TLB_MISC(ncid);
	while (start < end) {
		asm("tlbop %0, INV"::"r"(start));
		__nds32__isb();
		start += PAGE_SIZE;
	}
	SET_TLB_MISC(ocid);
	spin_unlock_irqrestore(&cid_lock, flags);
}

void local_flush_tlb_page(struct vm_area_struct *vma, unsigned long addr)
{
	unsigned long flags, ocid, ncid;

	spin_lock_irqsave(&cid_lock, flags);
	ocid = GET_TLB_MISC();
	ncid = (ocid & ~TLB_MISC_mskCID) | vma->vm_mm->context.id;
	SET_TLB_MISC(ncid);
	asm("tlbop %0, INV"::"r"(addr));
	__nds32__isb();
	SET_TLB_MISC(ocid);
	spin_unlock_irqrestore(&cid_lock, flags);
}
